'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelType = exports.ModelJSONType = exports.Model = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _tcomb = require('tcomb');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var maybeDate = (0, _tcomb.maybe)(_tcomb.Date);

var Model = exports.Model = function () {
  /**
   * @param {{$context: URIValue, $createdAt: Date|undefined, $updatedAt: Date|undefined, $deletedAt: Date|undefined}} fields
   */
  function Model(fields) {
    _classCallCheck(this, Model);

    var $context = fields.$context,
        $createdAt = fields.$createdAt,
        $updatedAt = fields.$updatedAt,
        $deletedAt = fields.$deletedAt;

    _uri2.default.Type($context);
    maybeDate($createdAt);
    maybeDate($updatedAt);
    maybeDate($deletedAt);
    this.$context = $context;
    this.$links = [];
    this.$createdAt = $createdAt;
    this.$updatedAt = $updatedAt;
    this.$deletedAt = $deletedAt;
  }

  /**
   * @returns {{$context: string, $links: Array<{href: string, $context: string}>}}
   */


  _createClass(Model, [{
    key: 'toJSON',
    value: function toJSON() {
      return {
        $context: this.$context.toString(),
        $createdAt: this.$createdAt ? this.$createdAt.toISOString() : undefined,
        $updatedAt: this.$updatedAt ? this.$updatedAt.toISOString() : undefined,
        $deletedAt: this.$deletedAt ? this.$deletedAt.toISOString() : undefined,
        $links: this.$links
      };
    }

    /**
     * @param {{$context: string, $createdAt: string|undefined, $updatedAt: string|undefined, $deletedAt: string|undefined}} data
     * @returns {Model}
     */

  }, {
    key: '$modifiedAt',


    /**
     * Returns the timestamp when the model was modified the last time, which is the latest value of
     * createdAt, updatedAt or deletedAt
     *
     * @returns {Date|undefined}
     */
    get: function get() {
      if (this.$deletedAt) {
        return this.$deletedAt;
      }
      if (this.$updatedAt) {
        return this.$updatedAt;
      }
      return this.$createdAt;
    }
  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      ModelJSONType(data);
      return new Model({
        $context: new _uri2.default(data.$context),
        $createdAt: data.$createdAt ? new Date(data.$createdAt) : undefined,
        $updatedAt: data.$updatedAt ? new Date(data.$updatedAt) : undefined,
        $deletedAt: data.$deletedAt ? new Date(data.$deletedAt) : undefined
      });
    }
  }]);

  return Model;
}();

var ModelJSONType = exports.ModelJSONType = (0, _tcomb.struct)({
  $context: _tcomb.String,
  $createdAt: (0, _tcomb.maybe)(_tcomb.String),
  $updatedAt: (0, _tcomb.maybe)(_tcomb.String),
  $deletedAt: (0, _tcomb.maybe)(_tcomb.String)
}, 'ModelJSONType');
var ModelType = exports.ModelType = (0, _tcomb.irreducible)('ModelType', function (x) {
  return x instanceof Model;
});